# Nicked a bunch of this from Hy
# https://github.com/hylang/hy/blob/master/hy/cmdline.py
import argparse
import os
import sys

from core import cfg
from core import barf
import scrib


USAGE = "%(prog)s [arg]"
VERSION = "%(prog)s " + scrib.__version__
EPILOG = "  [arg]		 interface to load"

# Load registered interfaces or set up defaults
interfaces = cfg.set()
interfaces.load('interfaces.cfg', {
	'help': None,
	'cli': 'ScribCLI',
	'irc': 'ScribIRC'
}, suppress=True)

def cmdline_handler(name, argv):
	parser = argparse.ArgumentParser(
		prog="scrib",
		usage=USAGE,
		formatter_class=argparse.RawDescriptionHelpFormatter,
		epilog=EPILOG)

	# this will contain the script/program name and any arguments for it.
	parser.add_argument('args', nargs=argparse.REMAINDER,
						help=argparse.SUPPRESS)

	options = parser.parse_args(argv[1:])

	# User did "scrib <filename>"
	try:
		load(interfaces.__dict__[options.args[0]])
		# return run_file(options.args[0])
	except IndexError:
		usage()
	except IOError as x:
		barf.Barf('ERR', "scrib: Can't open interface '%s': [Errno %d] %s\n" %
			(x.filename, x.errno, x.strerror))
		sys.exit(x.errno)

# entry point for cmd line script "scrib"
def scrib_main():
	sys.exit(cmdline_handler("scrib", sys.argv))

def usage():
	# Filter out everything but registered interfaces
	for a in interfaces.__dict__.keys():
		if '_defaults' in a:
				ifacelist = interfaces.__dict__[a]

	barf.Barf('MSG', 'scrib bot. Usage:', False)
	barf.Barf('MSG', 'start.py [interface]', False)
	barf.Barf('MSG', 'Available interfaces: %s' % ', '.join(ifacelist.keys()), False)
	sys.exit()

def load(interface):
	if interface is None:
		usage()
	barf.Barf('MSG', 'Loading interface: %s' % interface)
	d = os.path.dirname(sys.modules['scrib'].__file__)
	os.system(os.path.join(d, 'interfaces/'+interface+'.py'))
	sys.exit()
