#! /usr/bin/env python
import random

from irc import IRCBot, run_bot
from core import scrib

# Identify yourself and send default settings
scrib = scrib.scrib('irc', {
	'host': 'irc.thescoundrels.net',
	'port': 6667,
	'nick': 'scrib',
	'quitmsg': 'Goodbye!',
	'chans': ['#scoundrels'],
	'chatrate': 0.05,
	'maxwords': 30
})

class ScribIRC(IRCBot):
	
	def __init__(self, *args, **kwargs):
		super(ScribIRC, self).__init__(*args, **kwargs)

	def log(self, sender, message, channel):
		say_something = self.is_ping(message) or (
			sender != self.conn.nick and random.random() < scrib.interface.chatrate
		)
		
		if self.is_ping(message):
			message = self.fix_ping(message)
		
		if message.startswith('/'):
			return

		if say_something:
			return scrib.reply(message)

	def command_patterns(self):
		return (
			('.*', self.log),
		)

if __name__ == "__main__":
	try:
		run_bot(ScribIRC, scrib.interface.host, scrib.interface.port, scrib.interface.nick, scrib.interface.chans)
	except KeyboardInterrupt:
		scrib.shutdown()
